/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package vip.xiaonuo.disk.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import vip.xiaonuo.common.exception.CommonException;
import vip.xiaonuo.common.page.CommonPageRequest;
import vip.xiaonuo.disk.domain.ClassTeam;
import vip.xiaonuo.disk.mapper.ClassTeamMapper;
import vip.xiaonuo.disk.param.ClassTeamAddParam;
import vip.xiaonuo.disk.param.ClassTeamEditParam;
import vip.xiaonuo.disk.param.ClassTeamIdParam;
import vip.xiaonuo.disk.param.ClassTeamPageParam;
import vip.xiaonuo.disk.service.ClassTeamService;
import vip.xiaonuo.disk.vo.classteam.ClassTeamVo;

import java.util.List;

/**
 * class_teamService接口实现类
 *
 * @author pans
 * @date  2025/07/01 19:24
 **/
@Service
public class ClassTeamServiceImpl extends ServiceImpl<ClassTeamMapper, ClassTeam> implements ClassTeamService {

    @Autowired
    private ClassTeamMapper classTeamMapper;

    @Override
    public Page<ClassTeamVo> page(ClassTeamPageParam classTeamPageParam) {
        Page<ClassTeamVo> page= classTeamMapper.page(CommonPageRequest.defaultPage(), classTeamPageParam);
        return page;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(ClassTeamAddParam classTeamAddParam) {
        ClassTeam classTeam = BeanUtil.toBean(classTeamAddParam, ClassTeam.class);
        this.save(classTeam);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(ClassTeamEditParam classTeamEditParam) {
        ClassTeam classTeam = this.queryEntity(classTeamEditParam.getId());
        BeanUtil.copyProperties(classTeamEditParam, classTeam);
        this.updateById(classTeam);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<ClassTeamIdParam> classTeamIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(classTeamIdParamList, ClassTeamIdParam::getId));
    }

    @Override
    public ClassTeamVo detail(ClassTeamIdParam classTeamIdParam) {
        return classTeamMapper.detail(classTeamIdParam.getId());
    }

    @Override
    public ClassTeam queryEntity(Long id) {
        ClassTeam classTeam = this.getById(id);
        if(ObjectUtil.isEmpty(classTeam)) {
            throw new CommonException("class_team不存在，id值为：{}", id);
        }
        return classTeam;
    }

}
